/*
 * special.h
 *
 *  Created on: Mar 1, 2011
 *      Author: lipari
 */

#ifndef SPECIAL_H_
#define SPECIAL_H_

#include <iostream>

// general version
template<typename T, typename U>
struct A {
	void print() {
		std::cout << "general version" << std::endl;
	}
};

// specialization on T = int
template<typename U>
struct A<int, U> {
	void print() {
		std::cout << "version with T == int" << std::endl;
	}
};

// specialization on U = int
template<typename T>
struct A<T, int> {
	void print() {
		std::cout << "version with U == int" << std::endl;
	}
};

// specialization on both
template<>
struct A<int, int> {
	void print() {
		std::cout << "version with T == int, U == int" << std::endl;
	}
};

struct Simple {};

template <unsigned n>
struct Num {
	static const unsigned num = n;
};

template <unsigned n>
struct VarNum {
    void p() { std::cout << "Number is " << n << std::endl; }
};

template <>
struct VarNum<0> {
    void p() { std::cout << "N is zero!!" << std::endl; }
};

template<typename T>
struct Cont {
	typedef T MyType;
};

namespace specialization_example {
	int run() ;
}

#endif /* SPECIAL_H_ */
