/*
 * typetraits.cpp
 *
 *  Created on: Apr 6, 2011
 *      Author: lipari
 */

#include <iostream>
#include <loki/TypeTraits.h>
#include "loki_example.h"

namespace loki_example {
	using namespace Loki;
	using namespace std;

#define PRINT_TYPE_PROPERTY(X, P) \
		cout << "("#X ") " #P " : " << TypeTraits<X>::P << endl;

	typedef int (*FunctionPtr)();
	typedef int (FunctionType)();

	class A {
		int i;
	public:
		void fun() {}
	};

	typedef void (A::*MemberFunctionPtr)();

	int traits() {

		cout << "Is A * a pointer? " << TypeTraits<A*>::isPointer << endl;
		cout << "is A a pointer ?" << TypeTraits<A>::isPointer << endl;

		PRINT_TYPE_PROPERTY(int *, isPointer);
		PRINT_TYPE_PROPERTY(int *, isFunction);
		PRINT_TYPE_PROPERTY(FunctionType, isFunction);
		PRINT_TYPE_PROPERTY(FunctionType, isFunctionPointer);
		PRINT_TYPE_PROPERTY(FunctionPtr, isFunctionPointer);
		PRINT_TYPE_PROPERTY(MemberFunctionPtr, isMemberFunctionPointer);

		PRINT_TYPE_PROPERTY(const A&, isReference);
		PRINT_TYPE_PROPERTY(const A&, isConst);

		PRINT_TYPE_PROPERTY(A, isConst);
		PRINT_TYPE_PROPERTY(A, isReference);

		PRINT_TYPE_PROPERTY(int, isStdIntegral)

		return 1;
	}
}
